#ifndef CONTROL_BAR_H
#define CONTROL_BAR_H

#include <gui/layoutview.h>
#include <gui/textview.h>
#include <gui/stringview.h>
#include <gui/button.h>
#include <util/message.h>


//
class ConnectBar : public os::LayoutView
{
public:
	ConnectBar();
	
public:
	os::String GetHost()
	{
		return m_pcHostText->GetBuffer()[0];
	}
	
	os::String GetUser()
	{
		return m_pcUserText->GetBuffer()[0];
	}
	
	os::String GetPassword()
	{
		return m_pcPassText->GetBuffer()[0];
	}
	
	int GetPort()
	{
		return atoi(m_pcPortText->GetBuffer()[0].c_str());
	}
	
private:
	void _Layout();
	
	
	//libsyllable functions
	os::Point GetPreferredSize(bool) const;
	void AllAttached();

private:
	os::HLayoutNode* m_pcRoot;
	
	os::StringView* m_pcHostString;
	os::TextView* m_pcHostText;
	
	os::StringView* m_pcUserString;
	os::TextView* m_pcUserText;
	
	os::StringView* m_pcPassString;
	os::TextView* m_pcPassText;
	
	os::StringView* m_pcPortString;
	os::TextView* m_pcPortText;
	
	os::Button* m_pcButton;
};

#endif

